
// ClouReaderDemoDlg.cpp : Implementation file
//

#include "stdafx.h"
#include "ClouReaderDemo.h"
#include "afxdialogex.h"
#include "ClouReaderDemoDlg.h"
#include "DlgConf.h"
#include "DlgWrite.h"
#include "DlgCustom.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog box for the about menu item of the application

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

	// Dialog box data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

	// implement
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CClouReaderDemoDlg Ի

CClouReaderDemoDlg::CClouReaderDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CClouReaderDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClouReaderDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_listCtrl);
	DDX_Control(pDX, IDC_C1, m_ants[0]);
	DDX_Control(pDX, IDC_C2, m_ants[1]);
	DDX_Control(pDX, IDC_C3, m_ants[2]);
	DDX_Control(pDX, IDC_C4, m_ants[3]);
	DDX_Control(pDX, IDC_C5, m_ants[4]);
	DDX_Control(pDX, IDC_C6, m_ants[5]);
	DDX_Control(pDX, IDC_C7, m_ants[6]);
	DDX_Control(pDX, IDC_C8, m_ants[7]);
	DDX_Control(pDX, IDC_C9, m_ants[8]);
	DDX_Control(pDX, IDC_C10, m_ants[9]);
	DDX_Control(pDX, IDC_C11, m_ants[10]);
	DDX_Control(pDX, IDC_C12, m_ants[11]);
	DDX_Control(pDX, IDC_C13, m_ants[12]);
	DDX_Control(pDX, IDC_C14, m_ants[13]);
	DDX_Control(pDX, IDC_C15, m_ants[14]);
	DDX_Control(pDX, IDC_C16, m_ants[15]);
	DDX_Control(pDX, IDC_C17, m_ants[16]);
	DDX_Control(pDX, IDC_C18, m_ants[17]);
	DDX_Control(pDX, IDC_C19, m_ants[18]);
	DDX_Control(pDX, IDC_C20, m_ants[19]);
	DDX_Control(pDX, IDC_C21, m_ants[20]);
	DDX_Control(pDX, IDC_C22, m_ants[21]);
	DDX_Control(pDX, IDC_C23, m_ants[22]);
	DDX_Control(pDX, IDC_C24, m_ants[23]);
	DDX_Control(pDX, IDC_COMBO1, m_comConn);
	DDX_Control(pDX, IDC_Single, m_singleRead);
	DDX_Control(pDX, IDC_Constant, m_constantRead);
}

BEGIN_MESSAGE_MAP(CClouReaderDemoDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_CONN, &CClouReaderDemoDlg::OnBnClickedBtnConn)
	ON_BN_CLICKED(IDC_BTN_TEST, &CClouReaderDemoDlg::OnBnClickedBtnTest)
	ON_BN_CLICKED(IDC_BTN_TESTBACK, &CClouReaderDemoDlg::OnBnClickedBtnTestback)
	ON_BN_CLICKED(IDC_BTN_READ1, &CClouReaderDemoDlg::OnBnClickedBtnRead1)
	ON_BN_CLICKED(IDC_BTN_READ2, &CClouReaderDemoDlg::OnBnClickedBtnRead2)
	ON_BN_CLICKED(IDC_BTN_STOP, &CClouReaderDemoDlg::OnBnClickedBtnStop)
	ON_BN_CLICKED(IDC_BTN_DISCONN, &CClouReaderDemoDlg::OnBnClickedBtnDisconn)
	ON_MESSAGE(WM_UPDATE_LISTCTRL, &CClouReaderDemoDlg::OnUpdateListCtrl)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_CONF, &CClouReaderDemoDlg::OnBnClickedBtnConf)
	ON_NOTIFY(NM_RCLICK, IDC_LIST1, &CClouReaderDemoDlg::OnNMRClickList1)
	ON_COMMAND(ID_INDEX_32771, &CClouReaderDemoDlg::OnIndex32771)
	ON_BN_CLICKED(IDC_BTN_READ3, &CClouReaderDemoDlg::OnBnClickedBtnRead3)
	ON_BN_CLICKED(IDC_BTN_GETVER, &CClouReaderDemoDlg::OnBnClickedBtnGetver)
	ON_BN_CLICKED(IDC_BTN_GETSN, &CClouReaderDemoDlg::OnBnClickedBtnGetsn)
	ON_BN_CLICKED(IDC_BTN_GETMAC, &CClouReaderDemoDlg::OnBnClickedBtnGetmac)
	ON_BN_CLICKED(IDC_BTN_GETBBVER, &CClouReaderDemoDlg::OnBnClickedBtnGetbbver)
END_MESSAGE_MAP()


// CClouReaderDemoDlg Message handler

CListCtrl* CClouReaderDemoDlg::g_list = NULL;
map<CString,long> CClouReaderDemoDlg::mp_list;
CString CClouReaderDemoDlg::connStr;
DWORD CClouReaderDemoDlg::startTime;
DWORD CClouReaderDemoDlg::count;

BOOL CClouReaderDemoDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Put "about." Menu items are added to the system menu.

	// IDM_ABOUTBOX Must be within the scope of the system command.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog box. The framework automatically performs 
	// this action when the main window of the application is not a dialog box
	SetIcon(m_hIcon, TRUE);			// Set large icons
	SetIcon(m_hIcon, FALSE);		// Set small icons

	// TODO: Add additional initialization code here
	m_listCtrl.InsertColumn(0, "EPC", LVCFMT_LEFT, 150);//Insert column
	m_listCtrl.InsertColumn(1, "TID", LVCFMT_LEFT, 150);//Insert column
	m_listCtrl.InsertColumn(2, "UserData", LVCFMT_LEFT, 150);//Insert column
	m_listCtrl.InsertColumn(3, "PWD", LVCFMT_LEFT, 150);//Insert column
	m_listCtrl.InsertColumn(4, "Count", LVCFMT_LEFT, 100);//Insert column
	m_listCtrl.InsertColumn(5, "Time", LVCFMT_LEFT, 200);//Insert column
	DWORD dwStyle = m_listCtrl.GetExtendedStyle();
	m_listCtrl.SetExtendedStyle(dwStyle | LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT);
	g_list = &m_listCtrl;
	//m_ant1.SetCheck(1);
	//m_ant2.SetCheck(0);
	for (int i=0; i<ANT_MAX; i++) {
		m_ants[i].SetCheck(0);
	}
	m_ants[0].SetCheck(1);
	m_comConn.AddString("192.168.1.116:9090");
	m_comConn.AddString("COM1:115200");
	m_comConn.AddString("UHF READER");
	m_comConn.SetCurSel(0);
	count = 0;
	isReading = false;
	SetTimer(1, 1000, NULL);
	GetDlgItem(IDC_BTN_CONF)->EnableWindow(false);
	m_singleRead.SetCheck(0);
	m_constantRead.SetCheck(1);
	GetDlgItem(IDC_BTN_READ1)->EnableWindow(false);
	GetDlgItem(IDC_BTN_READ2)->EnableWindow(false);
	GetDlgItem(IDC_BTN_READ3)->EnableWindow(false);
	//AfxBeginThread(CClouReaderDemoDlg::TestList, NULL);
	return TRUE;  // Returns TRUE unless the focus is set to the control
}

void CClouReaderDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to the dialog box, you need the following 
// code to draw the icon. For MFC applications that use the document / view 
// model, this will be done automatically by the framework.

void CClouReaderDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Device context for drawing

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center the icon in the workspace rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//The system calls this function to get the cursor display 
//when the user drags the minimized window.
HCURSOR CClouReaderDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CClouReaderDemoDlg::OnBnClickedBtnConn()
{
	// TODO: Add the control notification handler code here
	CL_CALLBACK clCall = CClouReaderDemoDlg::TagCallBack;
	int iPos = m_comConn.GetCurSel();
	m_comConn.GetWindowText(connStr);

	if (iPos == -1) 
	{
		char *pConn = connStr.GetBuffer();
		if (strncmp(pConn, "COM", 3) == 0) 
		{
			iPos = 1;
		}
	}

	switch (iPos)
	{
	case -1:
	case 0:
		if (CLOpenTcpConnect(connStr.GetBuffer(), clCall) == 0)
		{
			/*if (CLStopRead(connStr.GetBuffer()) == 0)
			{*/
			GetDlgItem(IDC_BTN_CONN)->EnableWindow(false);
			GetDlgItem(IDC_BTN_CONF)->EnableWindow(true);
			GetDlgItem(IDC_status)->SetWindowText("TCP Connect OK.");
			GetDlgItem(IDC_CONN)->SetWindowText("Connected.");
			GetDlgItem(IDC_BTN_READ1)->EnableWindow(true);
			GetDlgItem(IDC_BTN_READ2)->EnableWindow(true);
			GetDlgItem(IDC_BTN_READ3)->EnableWindow(true);
			//}
			//else
			//{
			//	CLCloseConnect(connStr.GetBuffer());
			//}
			return;
		}
		break;
	case 1:
		if (CLOpenSerialConnect(connStr.GetBuffer(), clCall) == 0)
		{
			//if (CLStopRead(connStr.GetBuffer()) == 0)
			//{
			GetDlgItem(IDC_BTN_CONN)->EnableWindow(false);
			GetDlgItem(IDC_BTN_CONF)->EnableWindow(true);
			GetDlgItem(IDC_status)->SetWindowText("COM Connect OK.");
			GetDlgItem(IDC_CONN)->SetWindowText("Connected.");
			GetDlgItem(IDC_BTN_READ1)->EnableWindow(true);
			GetDlgItem(IDC_BTN_READ2)->EnableWindow(true);
			GetDlgItem(IDC_BTN_READ3)->EnableWindow(true);
			//}
			//else
			//{
			//	CLCloseConnect(connStr.GetBuffer());
			//}
			return;
		}
		break;
	case 2:
		if (CLOpenUsbConnect(connStr.GetBuffer(), clCall) == 0)
		{
			//if (CLStopRead(connStr.GetBuffer()) == 0)
			//{
			GetDlgItem(IDC_BTN_CONN)->EnableWindow(false);
			GetDlgItem(IDC_BTN_CONF)->EnableWindow(true);
			GetDlgItem(IDC_status)->SetWindowText("USB Connect OK.");
			GetDlgItem(IDC_CONN)->SetWindowText("Connected.");
			GetDlgItem(IDC_BTN_READ1)->EnableWindow(true);
			GetDlgItem(IDC_BTN_READ2)->EnableWindow(true);
			GetDlgItem(IDC_BTN_READ3)->EnableWindow(true);
			//}
			//else
			//{
			//	CLCloseConnect(connStr.GetBuffer());
			//}
			return;
		}
		break;
	default:
		break;
	}
	GetDlgItem(IDC_status)->SetWindowText("Connect failed");
}

void CClouReaderDemoDlg::OnBnClickedBtnTest()
{
	// TODO: Add the control notification handler code here
	AfxMessageBox(CLTest());
}

void CLAPI CClouReaderDemoDlg::TagCallBack(CL_TAG* tag)
{
	Tag_Param* tp = new Tag_Param;
	tp->TagType = tag->TagType;
	if (tag->EPC_len > 0)
		tp->EPC = tag->EPC;
	if (tag->ReaderName_len > 0)
		tp->ReaderName = tag->ReaderName;
	if (tag->TID_len > 0)
		tp->TID = tag->TID;
	if (tag->UserData_len > 0)
		tp->UserData = tag->UserData;
	if (tag->TagetData_len > 0)
		tp->TagetData = tag->TagetData;
	if (tag->ReaderTime_len > 0)
		tp->ReaderTime = tag->ReaderTime;
	::PostMessage(AfxGetApp()->GetMainWnd()->GetSafeHwnd(), WM_UPDATE_LISTCTRL, 0, (LPARAM)tp);
}

BOOL CClouReaderDemoDlg::CmpListItem(Tag_Param* tp, int nRow)
{
	char buf[1024];
	int len = 1024;
	//tid
	g_list->GetItemText(nRow, 1, buf, len);
	CString tid = buf;
	//userdata
	g_list->GetItemText(nRow, 2, buf, len);
	CString userData = buf;
	//PWD
	g_list->GetItemText(nRow, 3, buf, len);
	CString targetData = buf;

	if (tp->TID==tid && tp->UserData==userData && tp->TagetData==targetData)
	{
		//Number of reads
		g_list->GetItemText(nRow, 4, buf, len);
		len = atoi(buf);
		++len;
		CString tmp; tmp.Format("%d", len);
		g_list->SetItemText(nRow, 4, tmp);

		// Read time
		g_list->SetItemText(nRow, 5, tp->ReaderTime);
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

LRESULT CClouReaderDemoDlg::OnUpdateListCtrl(WPARAM wParam, LPARAM lParam)
{
	Tag_Param* tp = (Tag_Param*)lParam;
	if (tp->TagType == -1)
	{
		GetDlgItem(IDC_status)->SetWindowText("Reading Stopped");
		delete tp;
		count = 0;
		return 0;
	}
	LVFINDINFO info;
	info.flags = LVFI_PARTIAL|LVFI_STRING;
	info.psz = tp->EPC;
	int nRow = g_list->FindItem(&info);
	while (nRow != -1)
	{
		if (CmpListItem(tp, nRow))
		{
			break;
		}
		else
		{
			nRow = g_list->FindItem(&info, nRow);
		}
	}
	if (nRow == -1)
	{
		int c = g_list->GetItemCount();
		nRow = g_list->InsertItem(c, tp->EPC);
		g_list->SetItemText(nRow, 1, tp->TID);
		g_list->SetItemText(nRow, 2, tp->UserData);
		g_list->SetItemText(nRow, 3, tp->TagetData);
		g_list->SetItemText(nRow, 4, "1");
		g_list->SetItemText(nRow, 5, tp->ReaderTime);
	}

	delete tp;
	++count;
	return 0;
}

void CClouReaderDemoDlg::CountInfo()
{
	DWORD curTime = GetTickCount();
	DWORD timer = (curTime - startTime) / 1000;
	if (timer < 1)
		return;
	DWORD timerMinites = timer / 60;
	DWORD timerSeconds = timer % 60;
	CString tmp;
	tmp.Format(_T("Time:%lu M %lu S"), timerMinites, timerSeconds);
	GetDlgItem(IDC_TIME)->SetWindowText(tmp);
	if (count != 0)
	{
		DWORD velocity = count / timer;
		tmp.Format(_T("Rate:%lu Tags/S"), velocity);
		GetDlgItem(IDC_SULV)->SetWindowText(tmp);
	}
	return;
}

void CLAPI CClouReaderDemoDlg::testCallBack(CL_TAG* tag)
{
	if (tag->ReaderName != NULL)
		AfxMessageBox(tag->ReaderName);
}

void CClouReaderDemoDlg::OnBnClickedBtnTestback()
{
	// TODO: Add the control notification handler code here
	CL_CALLBACK clCall = CClouReaderDemoDlg::testCallBack;
	CLTestCallBack(clCall);
}

void CClouReaderDemoDlg::OnBnClickedBtnRead1()
{
	// TODO: Add the control notification handler code here
	m_listCtrl.DeleteAllItems();

	int antValue = (CL_ANT)0;
	for (int i=0; i<ANT_MAX; i++) {
		if (m_ants[i].GetCheck()) {
			antValue |= (1<<i);
		}
	}
	if (0 == antValue) {
		antValue = 1;
	}
	ant = (CL_ANT)antValue;


	CL_READ_TYPE type = m_singleRead.GetCheck()==1 ? SINGLE_READ : CONSTANT_READ;
	if (CLReadEPC(connStr.GetBuffer(), ant, type) == 0)
	{
		GetDlgItem(IDC_status)->SetWindowText("Reading EPC...");
		if (type == CONSTANT_READ)
		{
			isReading = true;
			startTime = GetTickCount();
			GetDlgItem(IDC_BTN_READ1)->EnableWindow(false);
			GetDlgItem(IDC_BTN_READ2)->EnableWindow(false);
			GetDlgItem(IDC_BTN_READ3)->EnableWindow(false);
		}
	}
	else
	{
		GetDlgItem(IDC_status)->SetWindowText("Read EPC failed");
	}
}

void CClouReaderDemoDlg::OnBnClickedBtnRead2()
{
	// TODO: Add the control notification handler code here
	m_listCtrl.DeleteAllItems();

	int antValue = (CL_ANT)0;
	for (int i=0; i<ANT_MAX; i++) {
		if (m_ants[i].GetCheck()) {
			antValue |= (1<<i);
		}
	}
	if (0 == antValue) {
		antValue = 1;
	}
	ant = (CL_ANT)antValue;

	CL_READ_TYPE type = m_singleRead.GetCheck()==1 ? SINGLE_READ : CONSTANT_READ;
	if (CLReadEPC(connStr.GetBuffer(), ant, type, TID_FIELD) == 0)
	{
		GetDlgItem(IDC_status)->SetWindowText("Reading TID...");
		if (type == CONSTANT_READ)
		{
			isReading = true;
			startTime = GetTickCount();
			GetDlgItem(IDC_BTN_READ1)->EnableWindow(false);
			GetDlgItem(IDC_BTN_READ2)->EnableWindow(false);
			GetDlgItem(IDC_BTN_READ3)->EnableWindow(false);
		}
	}
	else
	{
		GetDlgItem(IDC_status)->SetWindowText("Read TID failed");
	}
}

void CClouReaderDemoDlg::OnBnClickedBtnStop()
{
	// TODO: Add the control notification handler code here
	if (CLStopRead(connStr.GetBuffer()) == 0)
	{
		GetDlgItem(IDC_status)->SetWindowText("Stop OK");
		if (isReading == true)
		{
			isReading = false;
			GetDlgItem(IDC_BTN_READ2)->EnableWindow(true);
			GetDlgItem(IDC_BTN_READ1)->EnableWindow(true);
			GetDlgItem(IDC_BTN_READ3)->EnableWindow(true);
		}
	}
	else
	{
		GetDlgItem(IDC_status)->SetWindowText("Stop failed");
	}
}


void CClouReaderDemoDlg::OnBnClickedBtnDisconn()
{
	// TODO: Add the control notification handler code here
	if (CLCloseConnect(connStr.GetBuffer()) == 0)
	{
		GetDlgItem(IDC_CONN)->SetWindowText("Not connected!");
		GetDlgItem(IDC_BTN_CONN)->EnableWindow(true);
		GetDlgItem(IDC_BTN_CONF)->EnableWindow(false);
		GetDlgItem(IDC_status)->SetWindowText("Disconnected OK");
		GetDlgItem(IDC_BTN_READ1)->EnableWindow(false);
		GetDlgItem(IDC_BTN_READ2)->EnableWindow(false);
		GetDlgItem(IDC_BTN_READ3)->EnableWindow(false);
	}
	else
	{
		GetDlgItem(IDC_status)->SetWindowText("Disconnected failed");
	}
}


void CClouReaderDemoDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add message handler code and / or call default values here
	switch (nIDEvent)
	{
	case 1:
		if (isReading)
			CountInfo();
		break;
	default:
		break;
	}
	CDialogEx::OnTimer(nIDEvent);
}


void CClouReaderDemoDlg::OnBnClickedBtnConf()
{
	// TODO: Add the control notification handler code here
	if (isReading)
		return;
	CDlgConf dlg;
	dlg.connStr = connStr;
	dlg.DoModal();
}


void CClouReaderDemoDlg::OnNMRClickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	// TODO: Add the control notification handler code here
	CMenu menu;
	menu.LoadMenu(IDR_MENU1);
	CMenu* pPopup = menu.GetSubMenu(0);
	CPoint pt;
	GetCursorPos(&pt);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON, pt.x, pt.y, this);

	*pResult = 0;
}

void CClouReaderDemoDlg::OnIndex32771()
{
	// TODO: Add the command processor code here
	if (isReading)
		return;
	POSITION ps;
	int nIndex;
	ps = m_listCtrl.GetFirstSelectedItemPosition();
	nIndex = m_listCtrl.GetNextSelectedItem(ps);
	if (nIndex == -1)
		return;
	CDlgWrite dlg;
	dlg.oldEpc = m_listCtrl.GetItemText(nIndex, 0);
	dlg.oldTid = m_listCtrl.GetItemText(nIndex, 1);
	if (dlg.oldEpc.IsEmpty())
		return;
	dlg.connStr = connStr;
	dlg.ant = ant;
	dlg.DoModal();
}


void CClouReaderDemoDlg::OnBnClickedBtnRead3()
{
	// TODO: Add the control notification handler code here
	CDlgCustom dc;
	Tag_Read_param* trp = new Tag_Read_param;
	dc.m_trp = trp;

	char* match=NULL;
	int* startPos=NULL; size_t start_len=0;
	int* readLen=NULL; size_t read_Len=0;

	startPos = new int[4];
	readLen = new int[4];
	for (int i=0; i<4; ++i)
	{
		startPos[i] = -1;
		readLen[i] = -1;
	}

	if (dc.DoModal() == IDOK)
	{
		CL_DATA_FIELD field = EPC_FIELD;
		if (trp->tid + trp->user + trp->target + trp->match == 0)
			return;
		if (trp->tid + trp->user + trp->target == 3)
		{
			field = TID_USER_HOLD;
			readLen[1] = trp->TIDReadLen;
			startPos[2] = trp->UserStart;
			readLen[2] = trp->UserLen;
			startPos[3] = trp->TargetStart;
			readLen[3] = trp->TargetLen;
		}
		if (trp->tid + trp->user + trp->target == 2)
		{
			if (trp->tid && trp->user)
			{
				field = TID_USER;
				//startPos[1] = -1;	//Tid has no start bit
				startPos[2] = trp->UserStart;
				readLen[1] = trp->TIDReadLen;
				readLen[2] = trp->UserLen;
			}
			if (trp->tid && trp->target)
			{
				field = TID_HOLD;
				startPos[3] = trp->TargetStart;
				readLen[1] = trp->TIDReadLen;
				readLen[3] = trp->TargetLen;
			}
			if (trp->user && trp->target)
			{
				field = USER_HOLD;
				startPos[2] = trp->UserStart;
				startPos[3] = trp->TargetStart;
				readLen[2] = trp->UserLen;
				readLen[3] = trp->TargetLen;
			}
		}
		if (trp->tid + trp->user + trp->target == 1)
		{
			if (trp->tid)
			{
				field = TID_FIELD;
				readLen[1] = trp->TIDReadLen;
			}
			if (trp->target)
			{
				field = HOLD_FIELD;
				startPos[3] = trp->TargetStart;
				readLen[3] = trp->TargetLen;
			}
			if (trp->user)
			{
				field = USER_FIELD;
				startPos[2] = trp->UserStart;
				readLen[2] = trp->UserLen;
			}
		}

		CString strMatch;
		if (trp->match && trp->matchStr.GetLength()>0)
		{
			if (trp->matchStr.GetLength() % 2 != 0)
				trp->matchStr += "0";
			int matchBitLen = strlen(trp->matchStr) * 4;
			strMatch.Format("%d,%d,%d,%s",
				trp->matchType,trp->matchStart,matchBitLen,trp->matchStr);
			match = strMatch.GetBuffer();
		}

		m_listCtrl.DeleteAllItems();
		
		int antValue = (CL_ANT)0;
		for (int i=0; i<ANT_MAX; i++) {
			if (m_ants[i].GetCheck()) {
				antValue |= (1<<i);
			}
		}
		if (0 == antValue) {
			antValue = 1;
		}
		ant = (CL_ANT)antValue;

		CL_READ_TYPE type = m_singleRead.GetCheck()==1 ? SINGLE_READ : CONSTANT_READ;
		int ret = CLReadEPC(connStr.GetBuffer(), ant, type, field, NULL, 
			match, startPos, 4, readLen, 4);
		if (ret == 0)
		{
			GetDlgItem(IDC_status)->SetWindowText("Custom Reading...");
			if (type == CONSTANT_READ)
			{
				isReading = true;
				startTime = GetTickCount();
				GetDlgItem(IDC_BTN_READ1)->EnableWindow(false);
				GetDlgItem(IDC_BTN_READ2)->EnableWindow(false);
				GetDlgItem(IDC_BTN_READ3)->EnableWindow(false);
			}
		}
		else
		{
			GetDlgItem(IDC_status)->SetWindowText("Custom Read failed");
		}
	}
	delete trp;
	delete[] startPos;
	delete[] readLen;
}

void CClouReaderDemoDlg::OnBnClickedBtnGetver()
{
	// TODO: Add the control notification handler code here
	char info[256]={0};
	char ver[128] = {0};
	char model[128] = {0};
	unsigned int elapse = 0;
	if (CLGetReaderInfo(connStr.GetBuffer(), ver, model, &elapse) == 0)
	{
		sprintf(info, "Version:%s\r\nModel:\%s\r\n Runtime:%dS", ver, model, elapse);
		AfxMessageBox(info);
	}
	else
	{
		AfxMessageBox("Read version failed");
	}
}


void CClouReaderDemoDlg::OnBnClickedBtnGetsn()
{
		// TODO: Add the control notification handler code here
	char sn[256] = {0};
	if (CLGetReaderSN(connStr.GetBuffer(), sn) == 0)
	{
		AfxMessageBox(sn);
	}
	else
	{
		AfxMessageBox("Read SN failed");
	}
}


void CClouReaderDemoDlg::OnBnClickedBtnGetmac()
{	// TODO: Add the control notification handler code here
	char mac[256] = {0};
	if (CLGetReaderMAC(connStr.GetBuffer(), mac) == 0)
	{
		AfxMessageBox(mac);
	}
	else
	{
		AfxMessageBox("Read MAC failed");
	}// TODO: Add the control notification handler code here
}


void CClouReaderDemoDlg::OnBnClickedBtnGetbbver()
{
	char ver[256] = {0};
	if (CLGetBaseBandInfo(connStr.GetBuffer(), ver) == 0)
	{
		AfxMessageBox(ver);
	}
	else
	{
		AfxMessageBox("Read baseband failed");
	}// TODO: Add the control notification handler code here
}
